﻿#region Copyright Syncfusion Inc. 2001 - 2013
// Copyright Syncfusion Inc. 2001 - 2013. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.Mvc.Shared;
using Syncfusion.Mvc.Schedule;
using System.Collections;
using ScheduleControlSample.Models;

namespace ScheduleControlSample.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            var data = new samplDataContext().Appointments.Take(100);
            return View(data);
        }
        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Index(Params args, SchedulePropertiesModel model)
        {
            samplDataContext db = new samplDataContext();

            int intMax = db.Appointments.ToList().Count > 0 ? db.Appointments.ToList().Max(p => p.Id) : 1;

            model.SetCurrentCultureInfo();



            // Create New appointment and insert into database

            if (args.CurrentAction == "Save")
            {

                DateTime startTime = Convert.ToDateTime(args.StartTime);

                DateTime endTime = Convert.ToDateTime(args.EndTime);

                Appointment appoint = new Appointment()

                {

                    Id = intMax + 1,

                    StartTime = startTime,

                    EndTime = endTime,

                    Subject = args.Subject,

                    Location = args.Location,

                    Owner = args.Owner,
                    
                    Description=args.Description,

                };



                db.Appointments.InsertOnSubmit(appoint);

            }

            else if (args.CurrentAction == "Edit")
            {

                var filterData = db.Appointments.Where(c => c.Id == Convert.ToInt32(args.AppID));

                if (filterData.Count() > 0)
                {

                    DateTime startTime = Convert.ToDateTime(args.StartTime);

                    DateTime endTime = Convert.ToDateTime(args.EndTime);

                    Appointment appoint = db.Appointments.Single(A => A.Id == Convert.ToInt32(args.AppID));

                    appoint.StartTime = startTime;

                    appoint.EndTime = endTime;

                    appoint.Subject = args.Subject;

                    appoint.Location = args.Location;

                    appoint.Description = args.Description;

                    appoint.Owner = args.Owner;

                }
               
            }

            db.SubmitChanges();

            ActionResult result = db.Appointments.ScheduleActions<ScheduleHtmlActionResult>();

            return result;
        }
        public ActionResult About()
        {
            return View();
        }
    }
}
